/*#######################################################################################
AVR Small Webserver 

Copyright (C) 2004 Ulrich Radig

#######################################################################################*/

#include "main.h"
#include "ftpd.h"

#if USE_FTPD

PROGMEM char FTP_USER_OK[] = {
"230 User logged in, proceed.\r\n"
"%END"
};

PROGMEM char FTP_CMD_N_IM[] = {
"502 Command not implemented.\r\n"
"%END"
};

PROGMEM char FTP_CONNECT[] = {
"220--------- Welcome to Ulis FTP Server [TLS] ----------\r\n"
"220-You are user number 1 of 1 allowed.\r\n"
"220 You will be disconnected after 15 minutes of inactivity.\r\n"
"%END"
};

PROGMEM char FTP_PWD[] = {
"257 \"/home/user\" is your current location\r\n"
"%END"
};

PROGMEM char FTP_CMD_OK[] = {
"200 Command okay.\r\n"
"%END"
};

//############################################################################
//
void ftpd (char* buffer,int *bufferlen)
//############################################################################
{			
 
	//Verwaltung Stackpointer
	unsigned char a;//Stack Speichplatz Default (0..10)
	if (TCP_Stack (buffer,bufferlen,&a)== 1)
		{
		return;//keine Daten fr Anwendung
		}

	tcp_socket= &tcpsockets[a]; //Pointer auf tcpsockets[a] holen
		
	//Antwort FTP Server Vorhanden 
	if ((buffer[TCP_HDRFLAGS+1]&ACK_FLAG) > 0 && tcp_socket->Status == TCP_SOCKET_OPEN1)
			{
			//Speichert Sequenzcounter und Aknowledgecounter
			tcp_store(buffer);		
			//Setzen des Ack Flag
			buffer[TCP_HDRFLAGS+1] |= ACK_FLAG;
			//FTP Server Antwort Packet
			tcp_add_data (FTP_CONNECT,buffer,bufferlen);	
			//Erzeugt ein TCP Packet 
			tcp_make(buffer);			
			//Sendet das erzeugte TCP Packet 
			Write_Ethernet_Frame (buffer,*bufferlen);
			tcp_socket->Status = TCP_SOCKET_OPEN2;
			return;
			}
		
		
	if ((buffer[TCP_HDRFLAGS+1]&PSH_FLAG) > 0 && tcp_socket->Status == TCP_SOCKET_OPEN2)
			{
			//Errechnet startpunkt der Daten im Tcp buffer
			//IP Headerlnge + TCP Headerlnge + Ethernetframe
			unsigned int result16 = ((buffer[IP_VERS_LEN] & 0x0F) << 2) + 
									 ((buffer[TCP_HDRFLAGS] & 0xF0) >>2) + 14;
				
				printf("Recieve: ");
				
				for (int b = result16;b <= (*bufferlen);b++)
					{
					if (buffer[b] == 0) {break;}
					printf("%c",buffer[b]);
					}
				printf("\n");
				
				//Speichert Sequenzcounter und Aknowledgecounter
				tcp_store(buffer);	
				
				//Setzen des Ack Flag
				buffer[TCP_HDRFLAGS+1] |= ACK_FLAG;
				
				//FTP Server Antwort Packet
				
				int command = memcmp(&buffer[result16],"USER",4); //Commando USER
				if ( command == 0) 
					{
					tcp_add_data (FTP_USER_OK,buffer,bufferlen);
					goto CMD_FOUND;
					}

				command = memcmp(&buffer[result16],"XPWD",4); //Commando PWD
				if ( command == 0) 
					{
					tcp_add_data (FTP_PWD,buffer,bufferlen);
					goto CMD_FOUND;
					}
				
				command = memcmp(&buffer[result16],"PWD",3); //Commando PWD
				if ( command == 0) 
					{
					tcp_add_data (FTP_PWD,buffer,bufferlen);
					goto CMD_FOUND;
					}
				
				command = memcmp(&buffer[result16],"NOOP",4); //Commando NOOP
				if ( command == 0) 
					{
					tcp_add_data (FTP_CMD_OK,buffer,bufferlen);
					goto CMD_FOUND;
					}
					
				command = memcmp(&buffer[result16],"QUIT",4); //Commando NOOP
				if ( command == 0) 
					{
					tcp_add_data (FTP_CMD_OK,buffer,bufferlen);
					tcp_socket->Store = 0;
					tcp_socket->Status = TCP_SOCKET_NOT_USE; //Ready to FTP Socket Close
					goto CMD_FOUND;
					}

				tcp_add_data (FTP_CMD_N_IM,buffer,bufferlen);

				CMD_FOUND:
				//Erzeugt ein TCP Packet 
				tcp_make(buffer);	
				
				//Sendet das erzeugte TCP Packet 
				Write_Ethernet_Frame (buffer,*bufferlen);
			return;		
			}
return;
}

#endif //USE_FTPD
