/*#######################################################################################
AVR Small Webserver 

Copyright (C) 2004 Ulrich Radig

Bei Fragen und Verbesserungen wendet euch per EMail an

mail@ulrichradig.de

oder im Forum meiner Web Page : www.ulrichradig.de


Dieses Programm ist freie Software. Sie knnen es unter den Bedingungen der 
GNU General Public License, wie von der Free Software Foundation verffentlicht, 
weitergeben und/oder modifizieren, entweder gem Version 2 der Lizenz oder 
(nach Ihrer Option) jeder spteren Version. 

Die Verffentlichung dieses Programms erfolgt in der Hoffnung, 
da es Ihnen von Nutzen sein wird, aber OHNE IRGENDEINE GARANTIE, 
sogar ohne die implizite Garantie der MARKTREIFE oder der VERWENDBARKEIT 
FR EINEN BESTIMMTEN ZWECK. Details finden Sie in der GNU General Public License. 

Sie sollten eine Kopie der GNU General Public License zusammen mit diesem 
Programm erhalten haben. 
Falls nicht, schreiben Sie an die Free Software Foundation, 
Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307, USA. 
#######################################################################################*/

#include "main.h"

//Die beiden hier knnte man vieleicht doch besser ins RAM legen. Holgi
//MAC Addresse des Web Servers
// mymac ist eine Variable und wird aus der Netzwerkkarte geladen
unsigned char mymac[] = {1,2,3,4,5,6};

//IP Addresse des Web Servers
const unsigned char MYIP[] = {192,168,100,221};

//############################################################################
//Hauptprogramm
int main (void)
//############################################################################
{
	UART_Init();

	#if USE_MMC	
		while (mmc_init() != 0) //ist der Rckgabewert ungleich NULL ist ein Fehler aufgetreten
								//MMC/SD-Karte wird dann neu Initialisiert
			{
			printf ("** Keine MMC/SD-Karte gefunden! **\n\n");
			}
		printf ("MMC/SD-Karte gefunden!\n\n");
		//Speichern der Cluster Size und Cluster Offset (Anfang Datenbereich)
		Cluster_Data_Store();
	#endif

	//Grundinizialisierung der Netzwerkkarte
	Init_Realtek_Network_Card();

	if(ReadRTL(0) == 34) printf ("Init: Okay 34"); else printf ("Init: ERROR(%d)",ReadRTL(0));

	//Ausgabe meiner MAC Adresse auf Serieller Schnittstelle
	printf ("\nMy Mac: %02X.%02X.%02X.%02X.%02X.%02X\n",mymac[0],mymac[1],mymac[2],mymac[3],mymac[4],mymac[5]);

	//Ausgabe meiner IP Adresse auf Serieller Schnittstelle
	printf ("My IP : %d.%d.%d.%d\n\n",MYIP[0],MYIP[1],MYIP[2],MYIP[3]);	

	//Globale Interrupts Einschalten
	sei ();
	
	//Interrupt 4 Mega103/128 Interrupt 0 bei Mega32 
	//soll auslsen bei ansteigender Flanke
	Networkcard_INT_Set();
	
	//Interrupt 4 oder 0 Einschalten (fr die Netzwerkkarte)
	Networkcard_INT_Enable();

	#if USE_CLOCK
		Start_Clock();
	#endif
	
	// Initialisierung des LED-Pins
	TCCR2 &= 0x67;
	LED_LINES      &= (0<<LED_PIN);
	LED_LINES_DIR  |= (1<<LED_PIN);

	TCCR0 &= 0x4F;
	LED_LINES      &= (0<<LED_PIN_1);
	LED_LINES_DIR  |= (1<<LED_PIN_1);
	
	//Hauptprogramm luft stndig in einer Schleife und macht nichts
	while (1)
		{
		}
return (1);
}

