/*#######################################################################################
AVR Small Webserver 

Copyright (C) 2004 Ulrich Radig

#######################################################################################*/
//
// In dieser Datei werden Seiten an den Client geliefert. 
// Platzhalter werden gegen Daten getauscht.
//

#include "main.h"
#include "tcp.h" 
#include "mmc.h"

//Globale Variablen

unsigned long Seq_counter;
unsigned long Ack_counter;

struct TCP_Socket tcpsockets[Max_TCP_Sockets]; //Feld mit Max_TCP_Sockets Sockets
struct TCP_Socket *tcp_socket;                 //Pointer auf einen TCP_Socket

PGM_P pointerold;

unsigned int sitecounter=0;
unsigned int result16;

//############################################################################
void dec_out (char *buffer,char xx)
//############################################################################
// Ausgabe einer zwei- bis dreistelligen Dezimalzahl in eine Webseite
{	if (xx>99) {buffer[result16] = (unsigned char)(xx/100) + '0'; 
				 xx=xx%100; result16++;}
	buffer[result16] = (unsigned char)(xx/10) + '0'; result16++;
	buffer[result16] = (unsigned char)(xx%10) + '0'; result16++; }

//############################################################################
void hex_out (char *buffer,char xx)
//############################################################################
// Ausgabe einer zweistelligen HEX-Zahl in eine Webseite
{	buffer[result16] = (unsigned char)(xx/16) + '0'; 
	if (buffer[result16]>'9') buffer[result16] += 'A'-'9'-1; result16++;
	buffer[result16] = (unsigned char)(xx%16) + '0';
	if (buffer[result16]>'9') buffer[result16] += 'A'-'9'-1; result16++; }

//############################################################################
void bin_out (char *buffer)
//############################################################################
// Ausgabe des Wortes "checked" in eine Webseite
{	buffer[result16] = 'c'; result16++;
	buffer[result16] = 'h'; result16++;
	buffer[result16] = 'e'; result16++;
	buffer[result16] = 'c'; result16++;
	buffer[result16] = 'k'; result16++;
	buffer[result16] = 'e'; result16++;
	buffer[result16] = 'd'; result16++;
 }

//############################################################################
//
void tcp_store (char *buffer)
//############################################################################
{
	//Variablen Fr die Routine
	unsigned int result16;
	
	//Pointer auf TCP_Header
	struct TCP_Header *tcp;
	tcp = (struct TCP_Header *)&buffer[TCP_OFFSET];
	
	//Store seq number to Seq_counter
	Seq_counter = (tcp->TCP_Seqnum[0] << 8)+tcp->TCP_Seqnum[1];
	Seq_counter = Seq_counter << 16;
	Seq_counter = Seq_counter +(unsigned int) ((tcp->TCP_Seqnum[2] << 8)
								+tcp->TCP_Seqnum[3]);

    //Store ack number to ACK_counter
	Ack_counter = (tcp->TCP_Acknum[0] << 8)+tcp->TCP_Acknum[1];
	Ack_counter = Ack_counter << 16;
	Ack_counter = Ack_counter +(unsigned int) ((tcp->TCP_Acknum[2] << 8)
								+tcp->TCP_Acknum[3]);

	//Calculate next seq number
	if ((tcp->TCP_HdrFlags[1] & FIN_FLAG) == 0)
		{
		result16 = (buffer[IP_PKTLEN]<<8) + buffer[IP_PKTLEN+1];
		result16 = result16 - ((buffer[IP_VERS_LEN] & 0x0F) << 2)
							- ((buffer[TCP_HDRFLAGS] & 0xF0) >>2);

		if ((buffer[TCP_HDRFLAGS+1]&SYN_FLAG) > 0
		&& result16 == 0)
			{
			result16 = 1;
			}
		Seq_counter =Seq_counter + result16;
		}
	return;
}

//############################################################################
//
unsigned char tcp_add_data (PGM_P pointer,char *buffer,int *bufferlen)
//############################################################################
{
	//Variablen Fr die Routine
	unsigned char Data = 1;
	unsigned char Buffer_Full = 0;
	
	//Errechnet startpunkt der Daten im Tcp buffer
	//IP Headerlnge + TCP Headerlnge + Ethernetframe
	result16 = ((buffer[IP_VERS_LEN] & 0x0F) << 2) + 
				((buffer[TCP_HDRFLAGS] & 0xF0) >>2) + 14;

	for(;;)
		{
		Data = pgm_read_byte_near(pointer++);
		buffer[result16] = Data;
		result16++;
			//sind die daten lnger als ein Ethernetbuffer dann Abbruch
			if (result16 >  (MTU_SIZE - 1))
				{
				Buffer_Full = 1;
				//Speichern des Pointers
				pointerold = pointer;
				//Abbruch der Schleife
				break;
				}
				
			//% bedeutet es folgt eventuell eine Variable!	
			if (pgm_read_byte(pointer) =='%')
			{
				// Wird %VA gefunden, zugehrige Variable einfgen
				if (strncmp_P("VA",(pointer+1),2) == 0)
				{ pointer++;  pointer++;  pointer++;	//don't show "%VA*"
					if (pgm_read_byte(pointer) =='1') // %VA1 = Variable1; 5 stellige Dezimalzahl
					{	unsigned int tmp=sitecounter;
						char counter[5]; 
						for(unsigned char i=0; i<5; i++)
							{ counter[i] = (unsigned char)(tmp%10) + '0';	tmp/=10;}          
						for(unsigned char i=0; i<5; i++)
							{ buffer[result16] = counter[4-i]; result16++;} 
					sitecounter++;}
					if (pgm_read_byte(pointer) =='2')	// %VA2 = Variable2; binrer Schalter
					{	if (VA2 ^ (pgm_read_byte(pointer+1) =='-')) bin_out (buffer); // 'checked' ausgeben
							pointer++; } //don't show "-,+" 
					if (pgm_read_byte(pointer) =='3')	// %VA3 = Variable3; binrer Schalter
					{	if (VA3 ^ (pgm_read_byte(pointer+1) =='-')) bin_out (buffer); // 'checked' ausgeben
							pointer++; } //don't show "-,+" 
					if (pgm_read_byte(pointer) =='h')	dec_out (buffer,hh); // Stunden einfgen
					if (pgm_read_byte(pointer) =='m')	dec_out (buffer,mm); // Minuten einfgen
					if (pgm_read_byte(pointer) =='s')	dec_out (buffer,ss); // Sekunden einfgen
					if (pgm_read_byte(pointer) =='u')	hex_out (buffer,mymac[0]); //MAC-Adresse
					if (pgm_read_byte(pointer) =='v')	hex_out (buffer,mymac[1]);
					if (pgm_read_byte(pointer) =='w')	hex_out (buffer,mymac[2]);
					if (pgm_read_byte(pointer) =='x')	hex_out (buffer,mymac[3]);
					if (pgm_read_byte(pointer) =='y')	hex_out (buffer,mymac[4]);
					if (pgm_read_byte(pointer) =='z')	hex_out (buffer,mymac[5]);
					if (pgm_read_byte(pointer) =='W')	dec_out (buffer,MYIP[0]); //IP-Adresse
					if (pgm_read_byte(pointer) =='X')	dec_out (buffer,MYIP[1]);
					if (pgm_read_byte(pointer) =='Y')	dec_out (buffer,MYIP[2]);
					if (pgm_read_byte(pointer) =='Z')	dec_out (buffer,MYIP[3]);
					pointer++; //don't show "1, h, m, s"
				}
				//Abbruch wenn %END erreicht wurde
				if (strncmp_P("END",(pointer+1),3) == 0)
				{	for(int a = 0;a<1000;a++){nop();};		//Wait a short Time		
					break;	}
			}
		}
	TCP_New_Packtlen (buffer,bufferlen,result16);
	return(Buffer_Full);
}

//############################################################################
//
char tcp_add_datastring (char *pointer,char *buffer,int *bufferlen)
//############################################################################
{
	//Variablen Fr die Routine
	unsigned int result16;
	unsigned char Data = 1;
	unsigned char Buffer_Full = 0;

	//Errechnet den Startpunkt der Daten im Tcp buffer
	//IP Headerlnge + TCP Headerlnge + Ethernetframe
	result16 = ((buffer[IP_VERS_LEN] & 0x0F) << 2) + 
				((buffer[TCP_HDRFLAGS] & 0xF0) >>2) + 14;
	for(;;)
		{
		Data = *pointer++;
		buffer[result16] = Data;
		result16++;
			//sind die Daten lnger als ein Ethernetbuffer dann Abbruch
			if (result16 >  (MTU_SIZE - 1))
				{
				Buffer_Full = 1;
				break;
				}
			//Abbruch wenn 0 erreicht wurde
			if (*pointer == 0)
				{
				//Wait a short Time
				for(int a = 0;a<1000;a++){nop();};
				break;
				}
		}
	TCP_New_Packtlen (buffer,bufferlen,result16);
	return(Buffer_Full);
}

//############################################################################
//
void TCP_New_Packtlen (char *buffer,int *bufferlen,unsigned int result16)	
//############################################################################
{	
	//addiert noch bufferheader zur neuen ethernetlnge
	result16 = result16 + 4;
	*bufferlen = result16;
	//Errechnet die neue ip bufferlnge aus Ethernet Lnge 
	//Ethernetframe - bufferheader
	result16 = result16 - 18;
	//schreibt neue IPlnge ins buffer (ip_pktlenH)
	buffer[IP_PKTLEN] = ((result16 & 0xFF00) >> 8);
	//schreibt neue IPlnge ins buffer (ip_pktlenL)
	buffer[IP_PKTLEN+1] = (result16 & 0x00FF);
	return;
}

//############################################################################
//
void tcp_make (char *buffer)
//############################################################################
{
	//Variablen Fr die Routine
	unsigned int result16;
	unsigned long result32 = 0x00000000;
	unsigned char DataH;
	unsigned char DataL;

	//Schreibt neuen seq und Ack Counter	
    buffer[TCP_ACKNUM] = (Seq_counter & 0xFF000000) >> 24;
    buffer[TCP_ACKNUM+1] = (Seq_counter & 0x00FF0000) >> 16;
    buffer[TCP_ACKNUM+2] = (Seq_counter & 0x0000FF00) >> 8;
    buffer[TCP_ACKNUM+3] = Seq_counter & 0x000000FF;

    buffer[TCP_SEQNUM] = (Ack_counter & 0xFF000000) >> 24;
    buffer[TCP_SEQNUM+1] = (Ack_counter & 0x00FF0000) >> 16;
    buffer[TCP_SEQNUM+2] = (Ack_counter & 0x0000FF00) >> 8;
    buffer[TCP_SEQNUM+3] = Ack_counter & 0x000000FF;

    //Tauscht den TCP source Port mit TCP destinations port yyyy >> XXXX

	DataH = buffer[TCP_SRCPORT];
    buffer[TCP_SRCPORT] = buffer[TCP_DESTPORT];
    buffer[TCP_DESTPORT] = DataH;

	DataL = buffer[TCP_SRCPORT+1];
    buffer[TCP_SRCPORT+1] = buffer[TCP_DESTPORT+1];
    buffer[TCP_DESTPORT+1] = DataL;

	//Erzeugt den IP Header	
    Make_IP_Header(buffer);

	//Berechnung der TCP Checksumme
	//Alle Daten im TCP Header werden addiert checksum wird deshalb
	//ersteinmal auf null gesetzt
	buffer[TCP_CHKSUM] = 0x00;
	buffer[TCP_CHKSUM+1] = 0x00;

	//Berechnet Headerlnge und Addiert Pseudoheaderlnge 2XIP = 8
	result16 = (buffer[IP_PKTLEN]<<8) + buffer[IP_PKTLEN+1] + 8;
	result16 = result16 - ((buffer[IP_VERS_LEN] & 0x0F) << 2);
	result32 = result16 - 2;

	//Pointer wird auf das erste buffer im IP Header gesetzt
	//Routine berechnet die Checksumme
	result16 = checksum (&buffer[IP_SRCADDR], result16, result32);

	//schreibt checksum ins buffer (INT H Byte)
	buffer[TCP_CHKSUM] = ((result16 & 0xFF00) >> 8);

	//schreibt checksum ins buffer (INT L Byte)
	buffer[TCP_CHKSUM+1] = (result16 & 0x00FF);

	//Habe Fertig!!
}

//############################################################################
//
void TCP_PORT_CLOSE (char *buffer,int *bufferlen)
//############################################################################
{
	//Speichert Sequenzcounter und Aknowledgecounter
	tcp_store(buffer);	
	//Setzen des FIN Flag
	buffer[TCP_HDRFLAGS+1] = ACK_FLAG | FIN_FLAG | PSH_FLAG;

	//Erzeugt ein TCP buffer 
	tcp_make(buffer);			
	//Sendet das erzeugte TCP buffer 
	Write_Ethernet_Frame (buffer,*bufferlen);
}

//############################################################################
//
int TCP_OPEN (char *buffer,int *bufferlen)
//############################################################################
{
 unsigned int tcp_srcport;

 tcp_srcport=(buffer[TCP_SRCPORT]<<8) + buffer[TCP_SRCPORT+1];

 unsigned char tcp_hdrflags1=buffer[TCP_HDRFLAGS+1];
 
	if ((tcp_hdrflags1 & SYN_FLAG) > 0 
	     && (tcp_hdrflags1 & (PSH_FLAG | ACK_FLAG)) == 0)
	{
		//Speichern des Socket
		for (unsigned char a=0;a<Max_TCP_Sockets;a++)
			{
			tcp_socket= &tcpsockets[a]; //Pointer auf tcpsockets[a] holen
			if (tcp_socket->Store == 0)
				{
				tcp_socket->Store = tcp_srcport;
				tcp_socket->Status = TCP_SOCKET_NOT_USE;
				break;
				}
			}
		//Speichert Sequenzcounter und Aknowledgecounter
		tcp_store(buffer);		
		//Setzen des Ack Flag
		buffer[TCP_HDRFLAGS+1] |= ACK_FLAG;
		//Erzeugt ein TCP buffer 
		tcp_make(buffer);			
		//Sendet das erzeugte TCP buffer 
		Write_Ethernet_Frame (buffer,*bufferlen);
		return(1);
	}
		
	if ((tcp_hdrflags1 & RST_FLAG) > 0) 
	{
		for (unsigned char a=0;a<Max_TCP_Sockets;a++)
			{
			tcp_socket= &tcpsockets[a]; //Pointer auf tcpsockets[a] holen
			if (tcp_socket->Store == tcp_srcport)
				{
				tcp_socket->Store = 0;
				break;
				}
			}
		return(1);
	}
		
	if ((tcp_hdrflags1 & FIN_FLAG) > 0) 
	{
		for (unsigned char a=0;a<Max_TCP_Sockets;a++)
			{
			tcp_socket= &tcpsockets[a]; //Pointer auf tcpsockets[a] holen

			if (tcp_socket->Store == tcp_srcport)
				{
				tcp_socket->Store = 0;
				break;
				}
			}
		//Setzen des Ack Flag
		buffer[TCP_HDRFLAGS+1] = RST_FLAG;
		//Speichert Sequenzcounter und Aknowledgecounter
		tcp_store(buffer);	
		//Seq_counter um 1 erhhen
		Seq_counter = Seq_counter + 1;
		//Erzeugt ein TCP buffer 
		tcp_make(buffer);			
		//Sendet das erzeugte TCP buffer 
		Write_Ethernet_Frame (buffer,*bufferlen);	
		return(1);
	}
return(0);
}

//############################################################################
//Verwaltet TCP Stack 
char TCP_Stack (char *buffer,int *bufferlen,unsigned char *Stackpointer)
//############################################################################
{
	//ist fr Verbindungsaufbau zustndig TCP SYNC
	if (TCP_OPEN(buffer,bufferlen)==1)
		{
		return(1);//keine Daten fr Anwendung
		}
	
	unsigned int	TCP_Socket = (buffer[TCP_SRCPORT]<<8) + buffer[TCP_SRCPORT+1];

	for (unsigned char a=0;a<Max_TCP_Sockets;a++)
		{
		tcp_socket= &tcpsockets[a]; //Pointer auf tcpsockets[a] holen

		if(TCP_Socket == tcp_socket->Store)
			{
			if ((buffer[TCP_HDRFLAGS+1]&PSH_FLAG) > 0 
				&& (tcp_socket->Status == TCP_SOCKET_OPEN1 || tcp_socket->Status == TCP_SOCKET_OPEN2))
				{
				*Stackpointer = a;
				return(0); //Daten fr Anwendung
				}
			
			if (tcp_socket->Status == TCP_SOCKET_CLOSE)
				{
				tcp_socket->Store = TCP_SOCKET_NOT_USE;
				tcp_socket->Status = 0; //TCP Socket wird im TCP STACK geschlossen
				printf("TCP Socket Close Socket:%d Stack:%d\n",TCP_Socket,a);
				TCP_PORT_CLOSE (buffer,bufferlen);
				*Stackpointer = a;
				return(1); //Keine Daten fr Anwendung
				}
			
			if (tcp_socket->Status == TCP_SOCKET_NOT_USE)
				{
				printf("TCP Socket Open Socket:%d Stack:%d\n",TCP_Socket,a);
				tcp_socket->Status = TCP_SOCKET_OPEN1; //TCP Socket wird im TCP Stack geffnet
				*Stackpointer = a;
				return(0); //ACK fr Anwendung
				}
			
			if ((buffer[TCP_HDRFLAGS+1]&ACK_FLAG) > 0 
				&& (tcp_socket->Status == TCP_SOCKET_OPEN1 || tcp_socket->Status == TCP_SOCKET_OPEN2))
				{
				*Stackpointer = a;
				return(0); //ACK fr Anwendung
				}
			}
		}
	return (1);
}




